; ROUTINE TO CLOSE A FILE
;
;  Function:
;       Closes a file
;  Input:
;       On entry BX contains the file handle
;  Output:
;       If file is closed; carry is clear
;       If file is not closed; carry is set, error code is in AX
; Registers used:
;       AX is modified; BX is used for input, AX for output.
; Routines used:
;       DOS call 3Eh(CLOSE)
;
closefile       proc    far
;
        mov     ah,3Eh          ; close a file
        int     21h             ; DOS call
;
        ret
;
closefile       endp
;


