; ROUTINE TO COMPARE TWO STRINGS
;
; Input:
;       DS:SI points to the source, DS:DI the destination.
;       CX has length of strings
; Output:
;       On exit flags indicate:
;               l = source < dest
;               e = source = dest
;               g = source > dest
; Registers used:
;       AX is modified
;       On entry data segment contains source
;       and extra segment contains destination.
;
compare proc    far
;
        push    si              ; save registers
        push    di
        push    cx
;
        repz    cmpsb           ; one compare does it !
;
        pop     cx              ; restore registers
        pop     di
        pop     si
        ret
;
compare endp
;
