; ROUTINE TO CONVERT FROM INTERNAL 8-BIT BINARY TO ASCII DECIMAL
;
dec8out proc     far
;
        push    ds              ; save registers
        push    di
        push    dx
        push    cx
        push    ax
;
        mov     ax,datas        ; point to data segment
        mov     ds,ax
;
; a binary number is in DL
;
; put the digits in a buffer
;
        mov     cx,0            ; initialize the counter
        mov     di,offset tbuff ; point to the buffer
dec8out1:
        push    cx              ; save CX
        mov     al,dl           ; AX has numerator
        mov     ah,0            ; clear upper half
        mov     cl,10           ; divisor of 10
        div     cl              ; divide
        mov     dl,al           ; get quotient
        mov     al,ah           ; get remainder
;
        add     al,30h          ; add 30h
        mov     [di],al         ; put in buffer
        inc     di              ; next byte
;
        pop     cx              ; restore CX for the count
        inc     cx              ; count the ddigit
        cmp     dl,0            ; done?
        jnz     dec8out1
;
; dump the buffer out
;
dec8out2:
        dec     di              ; back up through the buffer
        mov     al,[di]         ; get byte from buffer
        call    stdout          ; sent it out
        loop    dec8out2
;
        pop     ax              ; restore registers
        pop     cx
        pop     dx
        pop     di
        pop     ds
        ret                     ; return
;
dec8out endp
