; ROUTINE TO MAKE WHITE NOISE
;
white   proc    far
;
        push    dx              ;save registers
        push    cx
        push    ax
;
        mov     x1,bx           ; lower limit of frequencies
        mov     x2,cx           ; upper limit of frequencies
;
        mov     seed,0          ; initialize seed
        call    freq            ; convert the frequency
        call    toneset         ; set the frequency
        call    toneon          ; turn the tone on
;
        mov     cx,dx           ; get the number of times
white1
        push    cx              ; save count
        call    random          ; generate a random number (0-1)
        call    scale           ; scale between x1 and x2
        call    freq            ; convert the frequency
        call    toneset         ; set the tone
        pop     cx              ; restore count
        loop    white1
;
;turn off the tone
        call    toneoff         ; turn it off
;
        pop     ax              ; restore registers
        pop     cx
        pop     dx
        ret
;
white   endp

