; ROUTINE TO CONVERT FROM SINGLE PRECISION FLOATING POINT
; TO TEMP FLOATING POINT
;
sfp2tfp proc    near
;
clear lower part ofmantissa
        mov     fptemp1w0,0     ; clear word
        mov     fptemp1w2,0     ; clear word
        mov     fptemp1w4,0     ; clear word
;
; move rest of mantissa
        mov     ax,sfpbuffw0    ; low 2 bytes
        mov     fptemp1w6,ax    ; put in place
;
        mov     ax,sfpbuffw2    ; high 7 bits
        and     ax,007Fh        ; remove the sign
        or      ax,0080h        ; restore msb
        mov     fptemp1w8,ax    ; put in place
;
; move sign
        mov     al,sfpbuffb2    ; in upper byte
        and     al,80h          ; just sign bit
        mov     fptemp1b10,al   ; byte 10 of fptemp1
;
; move exponent
        mov     al,sfpbuffb3    ; byte 3 of sfp
        mov     ah,0            ; make into a word
        sub     ax,80h          ; remove bias
        mov     fptemp1w11,ax   ; its 16-bit 2's comp
;
        ret                     ; return
;
sfp2tfp endp





