; ROUTINE TO DISPLAY TEMPORARY DECIMAL FLOATING POINT NUMBERS
;
tdecshow        proc    near
;
; output the sign
        cmp     decsign,0       ; is the sign there?
        mov     al,' '          ; space if not
        je      tdecshow1
;
; output a minus sign
        mov     al,'-'          ; minus sign
tdecshow1:
        call    stdout          ; send it out
;
tdecshow2:
; output the fist digit and a decimal point
        lea     si,decbuff+21   ; point to first digit
        mov     al,[si]         ; get it
        dec     si              ; point to next digit
        add     al,30h          ; make it ASCII
        call    stdout          ; send it out
;
        mov     al,'.'          ; ASCII decimal point
        call    stdout          ; send it out
;
; output the rest of the decimal string
        mov     cx,7            ; only 7 more digits
tdecshow3:
        mov     al,[si]         ; get digit
        dec     si              ; point to next digit
        add     al,30h          ; make it ASCII
        call    stdout          ; send it out
        loop    tdecshow3
;
        mov     al,'E'          ; E for exponent
        call    stdout          ; send it out
;
; now the exponent
        mov     dx,decexp       ; grab exponent
        cmp     dx,0            ; check the sign
        mov     al,'+'          ; plus sign
        jge     tdecshow4       ; if nonnegative
;
; if negative exponent
        neg     dx              ; absolute value of exponent
        mov     al,'-'          ; minus isgn
;
tdecshow4:
        call    stdout          ; output sign of exponent
        call    dec16out        ; output exponent
;
        ret                     ; return
;
tdecshow        endp
