; ROUTINE TO HELP CONVERT FILES TO WORDSTAR FILES
;
; Function:
;       Filters a file, replacing any single cr/lf by a "soft"
;       cr/lf and any double cr/lf by a"soft" then a "hard" cr/lf.
;       Tabs are not expanded.
; Segments referenced:
;       Segments must be as specifiedfor entry to EXE files.
;
;
controlz        equ     1Ah     ; controlz
;
        extrn   stdinne:far,stdoutdr:far
;
;*************************************************************************
;
datas   segment public
;
lastbyte        db      0
;
datas   ends
;*************************************************************************
stacks  segment stack
        db      20 dup('stack   ')
stacks  ends
;************************************************************************
codes   segment
'
        assume  cs:codes,ds:datas
;
;  ROUTINE TO HELP CONVERT FILES TO WORDSTAR FILES
;
wsfilter        proc    far
;
; set up return
        push    ds              ; save for proper return
        mov     ax,0            ; points to beginning of segment
        push    ax              ; for the offset
;
; set up segments
        mov     ax,datas        ; new data segment
        mov     ds,ax           ; put in DS
        mov     es,ax           ; and in ES
;
; main loop
wsfilter1:
;
; get thr next character
        call    stdinne         ; get the character with out echo
;
; work on carraige returns
wsfilter2:
        cmp     al,0Dh          ; hard carraige return
        jne     wsfilter3       ; skip if not
        cmp     lastbyte,10     ; last character = linefeed ?
        je      wsfilter3       ; skip if so
        mov     al,8Dh          ; soft carraige return
;
; send the character out
wsfilter3:
        call    stdoutdr        ; send it out
        mov     lastbyte,al     ; update lastbyte
;
; check for end of file
        cmp     al,controlz     ; end of file ?
        jne     wsfilter1       ; if not back for more
;
; exit
wsfilterexit:
        ret
;
wsfilter        endp
codes   ends                    ; end of code segment
        end     wsfilter
;
